package com.zjinja.mcmod.decor.element_templates.renderer;

import com.zjinja.mcmod.decor.element_base.EBaseTileBlockForResourceSpecifiedRenderer;
import com.zjinja.mcmod.decor.elements.blocks.B_ExitSignWithSensor;
import com.zjinja.mcmod.decor.elements.te.TE_ExitSignWithSensor;
import com.zjinja.mcmod.decor.elements.te.TE_RenderResourceSpecifiedTileEntity;
import net.minecraft.block.Block;
import net.minecraft.client.Minecraft;
import net.minecraft.tileentity.TileEntity;
import net.minecraftforge.client.model.obj.WavefrontObject;

public class RTE_ExitSignWithSensor extends WaveFrontRenderer {

    @Override
    public void renderTileEntityAt(TileEntity te, double x, double y, double z, float scale){
        preRender(x, y, z);
        Block block = te.getWorldObj().getBlock(te.xCoord, te.yCoord, te.zCoord);
        int meta = te.getWorldObj().getBlockMetadata(te.xCoord, te.yCoord, te.zCoord);
        if(te instanceof TE_ExitSignWithSensor) {
            TE_ExitSignWithSensor tileEntity = (TE_ExitSignWithSensor) te;
            if (block instanceof B_ExitSignWithSensor) {
                B_ExitSignWithSensor ebl = (B_ExitSignWithSensor) block;
                if(tileEntity.isEmergency){
                    if(ebl.EmergencyRender != null) {
                        if(ebl.EmergencyRender.RenderModel != null) {
                            if(ebl.EmergencyRender.Texture != null) {
                                Minecraft.getMinecraft().getTextureManager().bindTexture(ebl.EmergencyRender.Texture);
                            }
                            if (ebl.EmergencyRender.RenderModel instanceof WavefrontObject) {
                                render((WavefrontObject) ebl.EmergencyRender.RenderModel, ebl, meta);
                            }
                        }
                    }
                }else {
                    if(tileEntity.isDetected){
                        if(ebl.DetectedRender != null) {
                            if(ebl.DetectedRender.RenderModel != null) {
                                if(ebl.DetectedRender.Texture != null) {
                                    Minecraft.getMinecraft().getTextureManager().bindTexture(ebl.DetectedRender.Texture);
                                }
                                if (ebl.DetectedRender.RenderModel instanceof WavefrontObject) {
                                    render((WavefrontObject) ebl.DetectedRender.RenderModel, ebl, meta);
                                }
                            }
                        }
                    }else {
                        if(ebl.NormalRender != null) {
                            if(ebl.NormalRender.RenderModel != null) {
                                if(ebl.NormalRender.Texture != null) {
                                    Minecraft.getMinecraft().getTextureManager().bindTexture(ebl.NormalRender.Texture);
                                }
                                if (ebl.NormalRender.RenderModel instanceof WavefrontObject) {
                                    render((WavefrontObject) ebl.NormalRender.RenderModel, ebl, meta);
                                }
                            }
                        }
                    }
                }
            }
        }
        postRender();
    }
}
