package com.zjinja.mcmod.decor.elements.blocks;

import com.zjinja.mcmod.decor.ZJinJaDecoration;
import com.zjinja.mcmod.decor.element_base.EBaseTileBlock;
import com.zjinja.mcmod.decor.element_base.EBaseTileBlockForResourceSpecifiedRenderer;
import com.zjinja.mcmod.decor.element_templates.renderer.TileRenderResourceSpecifiedRenderer;
import com.zjinja.mcmod.decor.elements.te.TE_RenderResourceSpecifiedTileEntity;
import com.zjinja.mcmod.decor.misc.RenderResource;
import com.zjinja.mcmod.decor.utils.model_dir_util.BoundingBoxVector;
import com.zjinja.mcmod.decor.utils.model_dir_util.OffsetVector;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;

public class B_CellingIntLamp extends EBaseTileBlockForResourceSpecifiedRenderer {

    public B_CellingIntLamp(String ModelName, String TextureName) {
        super(Material.wood, TE_RenderResourceSpecifiedTileEntity.class);
        setBasicProperty(1.0F, 1.0F, 10.0F, Block.soundTypeGlass);
        DirUtil.FastDefine_4Dir();
        DirUtil.DefineRelBoundingBox(new BoundingBoxVector(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F));
        RenderResourceData = new RenderResource();
        RenderResourceData.LoadBlockResource(ModelName, TextureName);

    }

    @Override
    public int onBlockPlaced(World world, int x, int y, int z, int side, float hitX, float hitY, float hitZ, int smeta)
    {
        return side;
    }

    @SideOnly(Side.CLIENT)
    @Override
    public Object GetTileRenderer(){
        return new TileRenderResourceSpecifiedRenderer();
    }

    @Override
    public TileEntity createNewTileEntity(World world, int meta) {
        return new TE_RenderResourceSpecifiedTileEntity();
    }

    @Override
    public void onBlockPlacedBy(World world, int x, int y, int z, EntityLivingBase player, ItemStack itemStack){
        DirUtil.FastPlaceConv_4Dir(world, x, y, z, player, itemStack);
        int meta = world.getBlockMetadata(x, y, z);
        OffsetVector ov = DirUtil.CalcOffsetFromRelOffset(meta, 0,-1,0);
        int nsx = x + ov.getIntX();
        int nsy = y + ov.getIntY();
        int nsz = z + ov.getIntZ();
        if(world.isAirBlock(nsx, nsy, nsz)) {
            Block SlaveBlock = ZJinJaDecoration.proxy.Registry.GetBlockByName("lightblocka");
            world.setBlock(nsx, nsy, nsz, SlaveBlock, meta, 2);
        }
    }

    @Override
    public void breakBlock(World world, int x, int y, int z, Block block, int meta){
        OffsetVector ov = DirUtil.CalcOffsetFromRelOffset(meta, 0,-1,0);
        int nsx = x + ov.getIntX();
        int nsy = y + ov.getIntY();
        int nsz = z + ov.getIntZ();
        super.breakBlock(world, x, y, z,block, meta);
        Block slave = world.getBlock(nsx, nsy, nsz);
        if(slave instanceof B_StaticSlaveBlock4Dir){
            B_StaticSlaveBlock4Dir b_staticSlaveBlock4Dir = (B_StaticSlaveBlock4Dir)slave;
            if(b_staticSlaveBlock4Dir.isWandering()){
                world.setBlockToAir(nsx, nsy, nsz);
            }
        }
    }
}
