package com.zjinja.mcmod.decor.elements.blocks;

import com.zjinja.mcmod.decor.ZJinJaDecoration;
import com.zjinja.mcmod.decor.elements.te.TE_ExitSignWithSensor;
import com.zjinja.mcmod.decor.utils.model_dir_util.BoundingBoxVector;
import com.zjinja.mcmod.decor.utils.model_dir_util.OffsetVector;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.ChatComponentText;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

public class B_ExitSignWithSensorS extends B_StaticSlaveBlock4Dir{

    public B_ExitSignWithSensorS() {
        super(
                new BoundingBoxVector(0.0F, 0.25F, 0.0F, 0.5F, 0.6875F, 0.0625F),
                2.0F, 0.1F, 10.0F, Block.soundTypeWood,
                -1, 0, 0, false, Material.wood
        );
    }

    @Override
    public boolean canProvidePower()
    {
        return true;
    }

    @Override
    public boolean canConnectRedstone(IBlockAccess world, int x, int y, int z, int side){return true;}

    @Override
    public int isProvidingStrongPower(IBlockAccess ib, int x, int y, int z, int side)
    {
        int meta = ib.getBlockMetadata(x, y, z);
        OffsetVector ov = DirUtil.CalcOffsetFromRelOffset(meta, -1, 0, 0);
        int nsx = x + ov.getIntX();
        int nsy = y + ov.getIntY();
        int nsz = z + ov.getIntZ();
        TileEntity ent = ib.getTileEntity(nsx, nsy, nsz);
        if(!(ent instanceof TE_ExitSignWithSensor)){
            return 0;
        }
        TE_ExitSignWithSensor entity = (TE_ExitSignWithSensor)ent;
        return (entity.isEmergency || entity.isDetected) ? 15 : 0;
    }

    @Override
    public int isProvidingWeakPower(IBlockAccess ib, int x, int y, int z, int side)
    {
        return isProvidingStrongPower(ib, x, y, z, side);
    }

    @Override
    public boolean onBlockActivated(World world, int x, int y, int z, EntityPlayer player, int side, float hitX, float hitY, float hitZ)
    {
        if(!world.isRemote) {
            int meta = world.getBlockMetadata(x, y, z);
            OffsetVector ov = DirUtil.CalcOffsetFromRelOffset(meta, -1, 0, 0);
            int nsx = x + ov.getIntX();
            int nsy = y + ov.getIntY();
            int nsz = z + ov.getIntZ();
            TileEntity ent = world.getTileEntity(nsx, nsy, nsz);
            if(!(ent instanceof  TE_ExitSignWithSensor)){
                return false;
            }
            TE_ExitSignWithSensor entity = (TE_ExitSignWithSensor)ent;
            entity.isEmergency = !entity.isEmergency;
            if (entity.isEmergency) {
                player.addChatMessage(new ChatComponentText(
                        ZJinJaDecoration.I18N.translateKey("cmsg.exitsignwsen.emgena")));
            } else {
                player.addChatMessage(new ChatComponentText(
                        ZJinJaDecoration.I18N.translateKey("cmsg.exitsignwsen.emgdis")));
            }
            world.markBlockForUpdate(entity.xCoord, entity.yCoord, entity.zCoord);
            entity.markDirty();
            NotifyPower(world, x, y, z);
        }
        return true;
    }

    public void NotifyPower(World world, int x, int y, int z){
        int meta = world.getBlockMetadata(x, y, z);
        Block thisblock = world.getBlock(x,y,z);
        OffsetVector ov1 = DirUtil.CalcOffsetFromRelOffset(meta, 0,0,-1);
        OffsetVector ov2 = DirUtil.CalcOffsetFromRelOffset(meta, 0,-1,-1);
        OffsetVector ov3 = DirUtil.CalcOffsetFromRelOffset(meta, 0,-2,-1);
        OffsetVector ov4 = DirUtil.CalcOffsetFromRelOffset(meta, -1,0,-1);
        OffsetVector ov5 = DirUtil.CalcOffsetFromRelOffset(meta, -1,-1,-1);
        OffsetVector ov6 = DirUtil.CalcOffsetFromRelOffset(meta, -1,-2,-1);
        world.notifyBlockOfNeighborChange(ov1.getIntX() + x, ov1.getIntY() + y, ov1.getIntZ() + z, thisblock);
        world.notifyBlockOfNeighborChange(ov2.getIntX() + x, ov2.getIntY() + y, ov2.getIntZ() + z, thisblock);
        world.notifyBlockOfNeighborChange(ov3.getIntX() + x, ov3.getIntY() + y, ov3.getIntZ() + z, thisblock);
        world.notifyBlockOfNeighborChange(ov4.getIntX() + x, ov4.getIntY() + y, ov4.getIntZ() + z, thisblock);
        world.notifyBlockOfNeighborChange(ov5.getIntX() + x, ov5.getIntY() + y, ov5.getIntZ() + z, thisblock);
        world.notifyBlockOfNeighborChange(ov6.getIntX() + x, ov6.getIntY() + y, ov6.getIntZ() + z, thisblock);
    }
}
