package com.zjinja.mcmod.decor.elements.blocks;

import com.zjinja.mcmod.decor.ZJinJaDecoration;
import com.zjinja.mcmod.decor.element_base.EBaseTileBlockForResourceSpecifiedRenderer;
import com.zjinja.mcmod.decor.elements.te.TE_FireExtinguisherBox;
import com.zjinja.mcmod.decor.element_templates.renderer.TileRenderResourceSpecifiedRenderer;
import com.zjinja.mcmod.decor.misc.RenderResource;
import com.zjinja.mcmod.decor.network.msg.GuiIdDef;
import com.zjinja.mcmod.decor.utils.model_dir_util.BoundingBoxVector;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;

import java.util.Random;

public class B_FireExtinguisherBox extends EBaseTileBlockForResourceSpecifiedRenderer {

    public B_FireExtinguisherBox() {
        super(Material.wood, TE_FireExtinguisherBox.class);
        setBasicProperty(4.0F, 0.0F, 10.0F, Block.soundTypeMetal);
        DirUtil.FastDefine_4Dir();
        Init();

    }

    protected void Init(){
        DirUtil.DefineRelBoundingBox(new BoundingBoxVector(0.0625F, 0.0F, 0.0F, 0.9375F, 0.8125F, 0.5625F));
        RenderResourceData = new RenderResource();
        RenderResourceData.LoadBlockResource("fireextinguisherbox", "fireextinguisherbox_tex");
    }

    @Override
    public void onBlockPlacedBy(World world, int x, int y, int z, EntityLivingBase player, ItemStack itemStack){
        DirUtil.FastPlaceConv_4Dir(world, x, y, z, player, itemStack);
    }

    @Override
    public int onBlockPlaced(World world, int x, int y, int z, int side, float hitX, float hitY, float hitZ, int smeta)
    {
        return side;
    }

    @SideOnly(Side.CLIENT)
    @Override
    public Object GetTileRenderer(){
        return new TileRenderResourceSpecifiedRenderer();
    }

    @Override
    public TileEntity createNewTileEntity(World world, int meta) {
        return new TE_FireExtinguisherBox();
    }


    @Override
    public boolean onBlockActivated(World world, int x, int y, int z,
                                    EntityPlayer player, int metadata, float what, float these, float are) {
        TileEntity tileEntity = world.getTileEntity(x,y,z);
        if (tileEntity == null || player.isSneaking()) {
            return false;
        }
        //code to open gui explained later
        player.openGui(ZJinJaDecoration.MODID, GuiIdDef.Gui_TileEntity, world, x, y, z);
        return true;
    }

    @Override
    public void breakBlock(World world, int x, int y, int z, Block par5, int par6) {
        dropItems(world, x, y, z);
        super.breakBlock(world, x, y, z, par5, par6);
    }

    private void dropItems(World world, int x, int y, int z) {
        Random rand = new Random();

        TileEntity tileEntity = world.getTileEntity(x, y, z);
        if (!(tileEntity instanceof IInventory)) {
            return;
        }
        IInventory inventory = (IInventory) tileEntity;

        for (int i = 0; i < inventory.getSizeInventory(); i++) {
            ItemStack item = inventory.getStackInSlot(i);

            if (item != null && item.stackSize > 0) {
                float rx = rand.nextFloat() * 0.8F + 0.1F;
                float ry = rand.nextFloat() * 0.8F + 0.1F;
                float rz = rand.nextFloat() * 0.8F + 0.1F;

                EntityItem entityItem = new EntityItem(world,
                        x + rx, y + ry, z + rz,
                        new ItemStack(item.getItem(), item.stackSize, item.getItemDamage()));

                if (item.hasTagCompound()) {
                    entityItem.getEntityItem().setTagCompound((NBTTagCompound) item.getTagCompound().copy());
                }

                float factor = 0.05F;
                entityItem.motionX = rand.nextGaussian() * factor;
                entityItem.motionY = rand.nextGaussian() * factor + 0.2F;
                entityItem.motionZ = rand.nextGaussian() * factor;
                world.spawnEntityInWorld(entityItem);
                item.stackSize = 0;
            }
        }
    }
}
