package com.zjinja.mcmod.decor.elements.blocks;

import com.zjinja.mcmod.decor.ZJinJaDecoration;
import com.zjinja.mcmod.decor.element_base.EBaseTileBlock;
import com.zjinja.mcmod.decor.element_base.EBaseTileBlockForResourceSpecifiedRenderer;
import com.zjinja.mcmod.decor.element_templates.renderer.RTE_ManholeCover;
import com.zjinja.mcmod.decor.element_templates.renderer.TileRenderResourceSpecifiedRenderer;
import com.zjinja.mcmod.decor.elements.te.TE_FireExtinguisherBox;
import com.zjinja.mcmod.decor.elements.te.TE_ManholeCover;
import com.zjinja.mcmod.decor.misc.RenderResource;
import com.zjinja.mcmod.decor.network.msg.GuiIdDef;
import com.zjinja.mcmod.decor.utils.model_dir_util.BoundingBoxVector;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.world.World;

import java.util.Random;

public class B_ManholeCover extends EBaseTileBlock {
    public RenderResource CloseRR;
    public RenderResource OpenRR;

    public B_ManholeCover(String Texture) {
        super(Material.wood, TE_ManholeCover.class);
        setBasicProperty(5.0F, 0.0F, 10.0F, Block.soundTypeMetal);
        DirUtil.FastDefine_4Dir();
        DirUtil.DefineRelBoundingBox(new BoundingBoxVector(0.0F, 0.9375F, 0.0F, 1.0F, 1.0F, 1.0F));
        BoundingBoxVector nobb = new BoundingBoxVector(0,0,0,0,0,0);
        DirUtil.AbsBoundingBoxMetaTable[4] = nobb;
        DirUtil.AbsBoundingBoxMetaTable[5] = nobb;
        DirUtil.AbsBoundingBoxMetaTable[6] = nobb;
        DirUtil.AbsBoundingBoxMetaTable[7] = nobb;
        CloseRR = new RenderResource();
        OpenRR = new RenderResource();
        CloseRR.LoadBlockResource("manholecover", Texture);
        OpenRR.LoadBlockResource("manholecoveropen", Texture);
    }

    @Override
    public void onBlockPlacedBy(World world, int x, int y, int z, EntityLivingBase player, ItemStack itemStack){
        DirUtil.FastPlaceConv_4Dir(world, x, y, z, player, itemStack);
    }

    @Override
    public int onBlockPlaced(World world, int x, int y, int z, int side, float hitX, float hitY, float hitZ, int smeta)
    {
        return side;
    }

    @SideOnly(Side.CLIENT)
    @Override
    public Object GetTileRenderer(){
        return new RTE_ManholeCover();
    }

    @Override
    public TileEntity createNewTileEntity(World world, int meta) {
        return new TE_ManholeCover();
    }


    @Override
    public boolean onBlockActivated(World world, int x, int y, int z,
                                    EntityPlayer player, int _metadata, float what, float these, float are) {
        int metadata = world.getBlockMetadata(x, y, z);
        Block phblock = world.getBlock(x, y + 1, z);
        Block newphb = ZJinJaDecoration.proxy.Registry.GetBlockByName("mhcoph");
        if(metadata > 3 && metadata < 8){
            if(phblock instanceof B_ManholeCoverOpenPH){
                world.setBlock(x, y, z, Blocks.air, 0, 2);
            }
            world.setBlockMetadataWithNotify(x, y, z, metadata - 4, 2);
            return true;
        }else if(metadata < 4){
            if(world.isAirBlock(x, y + 1, z)){
                world.setBlock(x, y + 1, z, newphb, metadata, 2);
                world.setBlockMetadataWithNotify(x, y, z, metadata + 4, 2);
                return true;
            }else {
                return false;
            }
        }else {
            //ZJinJaDecoration.logger.info("Set Meta To 0 @ act MBlock");
            world.setBlockMetadataWithNotify(x, y, z, 0, 2);
        }
        return false;
    }

    @Override
    public void breakBlock(World world, int x, int y, int z, Block par5, int par6) {
        Block phblock = world.getBlock(x, y + 1, z);
        if(phblock instanceof B_ManholeCoverOpenPH){
            world.setBlockToAir(x, y + 1, z);
        }
        super.breakBlock(world, x, y, z, par5, par6);
    }
}
