package com.zjinja.mcmod.decor.elements.blocks;

import com.zjinja.mcmod.decor.ZJinJaDecoration;
import com.zjinja.mcmod.decor.element_base.EBaseTileBlockForResourceSpecifiedRenderer;
import com.zjinja.mcmod.decor.elements.te.TE_H7FTDSignS;
import com.zjinja.mcmod.decor.elements.te.TE_ManholeCoverOpenPH;
import com.zjinja.mcmod.decor.utils.model_dir_util.BoundingBoxVector;
import com.zjinja.mcmod.decor.utils.model_dir_util.OffsetVector;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;

public class B_ManholeCoverOpenPH extends EBaseTileBlockForResourceSpecifiedRenderer {

    public B_ManholeCoverOpenPH() {
        super(Material.iron, TE_H7FTDSignS.class);
        setBasicProperty(5.0F, 0.0F, 10.0F, soundTypeMetal);
        DirUtil.FastDefine_4Dir();
        DirUtil.DefineRelBoundingBox(new BoundingBoxVector(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.0625F));
    }

    @Override
    public void onBlockPlacedBy(World world, int x, int y, int z, EntityLivingBase player, ItemStack itemStack){
        DirUtil.FastPlaceConv_4Dir(world, x, y, z, player, itemStack);
    }

    @Override
    public int onBlockPlaced(World world, int x, int y, int z, int side, float hitX, float hitY, float hitZ, int smeta)
    {
        return side;
    }

    @Override
    public boolean AutoBindRenderer(){return false; }

    @SideOnly(Side.CLIENT)
    @Override
    public Object GetTileRenderer(){
        return null;
    }

    @Override
    public TileEntity createNewTileEntity(World world, int meta) {
        return new TE_ManholeCoverOpenPH();
    }

    @Override
    public void breakBlock(World world, int x, int y, int z, Block block, int meta){
        Block mblock = world.getBlock(x, y - 1, z);
        if(mblock instanceof B_ManholeCover){
            int mbmeta =  world.getBlockMetadata(x, y - 1, z);
            if(mbmeta > 3 && mbmeta < 8) {
                world.setBlockMetadataWithNotify(x, y - 1, z, mbmeta - 4, 2);
            }else if(mbmeta < 4){
                return;
            }else {
                //ZJinJaDecoration.logger.info("Set Meta To 0 @ break PHBlock");
                world.setBlockMetadataWithNotify(x, y - 1, z, 0, 2);
            }
        }
    }

    @Override
    public boolean onBlockActivated(World world, int x, int y, int z,
                                    EntityPlayer player, int metadata, float what, float these, float are) {
        Block mblock = world.getBlock(x, y - 1, z);
        if(mblock instanceof B_ManholeCover){
            int mbmeta =  world.getBlockMetadata(x, y - 1, z);
            if(mbmeta > 3 && mbmeta < 8) {
                world.setBlockMetadataWithNotify(x, y - 1, z, mbmeta - 4, 2);
                world.setBlock(x, y, z, Blocks.air, 0, 2);
                return true;
            }else if(mbmeta < 4){
                return true;
            }else {
                //ZJinJaDecoration.logger.info("Set Meta To 0 @ act PHBlock");
                world.setBlockMetadataWithNotify(x, y - 1, z, 0, 2);
            }
        }
        return false;
    }

}
