package com.zjinja.mcmod.decor.elements.te;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.NetworkManager;
import net.minecraft.network.Packet;
import net.minecraft.network.play.server.S35PacketUpdateTileEntity;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;

public class TE_ExitSignWithSensor extends TileEntity {
    public boolean isEmergency;
    public boolean isDetected;

    public TE_ExitSignWithSensor(){
        super();
    }

    @Override
    public void writeToNBT(NBTTagCompound NBTC)
    {
        super.writeToNBT(NBTC);
        NBTC.setBoolean("fEmg", isEmergency);
        NBTC.setBoolean("fDet", isDetected);
    }

    @Override
    public void readFromNBT(NBTTagCompound NBTC)
    {
        super.readFromNBT(NBTC);
        isEmergency = NBTC.getBoolean("fEmg");
        isDetected = NBTC.getBoolean("fDet");
    }

    @Override
    public Packet getDescriptionPacket()
    {
        NBTTagCompound syncData = new NBTTagCompound();
        syncData.setBoolean("fEmg", isEmergency);
        syncData.setBoolean("fDet", isDetected);
        return new S35PacketUpdateTileEntity(this.xCoord, this.yCoord, this.zCoord, 1, syncData);
    }

    @Override
    public void onDataPacket(NetworkManager net, S35PacketUpdateTileEntity pkt)
    {
        NBTTagCompound syncData = pkt.func_148857_g();
        isEmergency = syncData.getBoolean("fEmg");
        isDetected = syncData.getBoolean("fDet");
    }


    @Override
    @SideOnly(Side.CLIENT)
    public AxisAlignedBB getRenderBoundingBox()
    {
        return AxisAlignedBB.getBoundingBox(xCoord - 1, yCoord, zCoord -1, xCoord + 2, yCoord + 1, zCoord + 2);
    }
}
