package com.zjinja.mcmod.decor.misc;

import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.common.config.Configuration;

public class ConfigLoader {

    public static class ConfigInstance{
        public boolean enableDebug;
        public String locale;
        public boolean enableNZEAPI;
        public double DoorSensorDetectDistance;
        public int DoorSensorDetectHeight;
    }

    public static ConfigInstance Conf;

    public ConfigLoader(FMLPreInitializationEvent event){
        Configuration config = new Configuration(event.getSuggestedConfigurationFile());
        config.load();

        Conf = new ConfigInstance();
        Conf.enableDebug = config.get(Configuration.CATEGORY_GENERAL,"EnableDebug",false).getBoolean(false);
        Conf.enableNZEAPI = config.get(Configuration.CATEGORY_GENERAL,"EnableNZEAPI",false).getBoolean(false);
        Conf.locale = config.get(Configuration.CATEGORY_GENERAL,"Locale","zh_CN").getString();
        Conf.DoorSensorDetectDistance = config.get(Configuration.CATEGORY_GENERAL, "DoorSensorDetectDistance", 1.5).getDouble();
        Conf.DoorSensorDetectHeight = config.get(Configuration.CATEGORY_GENERAL, "DoorSensorDetectHeight", 3).getInt();
        config.save();
    }
}
