package com.zjinja.mcmod.decor.network.msg;

import com.zjinja.mcmod.decor.elements.items.I_FireExtinguisher;
import cpw.mods.fml.common.network.simpleimpl.IMessage;
import cpw.mods.fml.common.network.simpleimpl.IMessageHandler;
import cpw.mods.fml.common.network.simpleimpl.MessageContext;
import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;

public class MsgFireExtinguishing implements IMessage {
    private int posX, posY, posZ, side;

    public MsgFireExtinguishing(){ }

    public MsgFireExtinguishing(int x, int y, int z,int _side){
        posX = x;
        posY = y;
        posZ = z;
        side = _side;
    }


    @Override
    public void fromBytes(ByteBuf buf) {
        posX = buf.readInt();
        posY = buf.readInt();
        posZ = buf.readInt();
        side = buf.readInt();

    }

    @Override
    public void toBytes(ByteBuf buf) {
        buf.writeInt(posX);
        buf.writeInt(posY);
        buf.writeInt(posZ);
        buf.writeInt(side);
    }

    public static class Handler implements IMessageHandler<MsgFireExtinguishing, IMessage>{

        public Handler(){}

        @Override
        public IMessage onMessage(MsgFireExtinguishing msg, MessageContext ctx) {
            EntityPlayerMP entityPlayer = ctx.getServerHandler().playerEntity;
            World world = entityPlayer.worldObj;
            ItemStack itemStack = entityPlayer.getHeldItem();
            if(itemStack == null)return null;
            if(itemStack.getItem() instanceof I_FireExtinguisher){
                for(int i = -2; i < 3; i++){
                    for(int j = -2; j < 3; j++){
                        for(int k= -2; k < 3; k++){
                            world.extinguishFire(entityPlayer,msg.posX + i,msg.posY + j,msg.posZ + k, msg.side);
                        }
                    }
                }
                itemStack.damageItem(1, entityPlayer);
            }
            return null;
        }
    }
}
