package com.zjinja.mcmod.decor.network.msg;

import com.zjinja.mcmod.decor.elements.items.I_BlockInfoTerm;
import cpw.mods.fml.common.network.simpleimpl.IMessage;
import cpw.mods.fml.common.network.simpleimpl.IMessageHandler;
import cpw.mods.fml.common.network.simpleimpl.MessageContext;
import io.netty.buffer.ByteBuf;
import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ChatComponentText;
import net.minecraft.world.World;

public class MsgShowBlockInfo implements IMessage {
    private int posX, posY, posZ;

    public MsgShowBlockInfo(){ }

    public MsgShowBlockInfo(int x, int y, int z){
        posX = x;
        posY = y;
        posZ = z;
    }


    @Override
    public void fromBytes(ByteBuf buf) {
        posX = buf.readInt();
        posY = buf.readInt();
        posZ = buf.readInt();

    }

    @Override
    public void toBytes(ByteBuf buf) {
        buf.writeInt(posX);
        buf.writeInt(posY);
        buf.writeInt(posZ);
    }

    public static class Handler implements IMessageHandler<MsgShowBlockInfo, IMessage>{

        public Handler(){}

        @Override
        public IMessage onMessage(MsgShowBlockInfo msg, MessageContext ctx) {
            EntityPlayerMP entityPlayer = ctx.getServerHandler().playerEntity;
            World world = entityPlayer.worldObj;
            ItemStack itemStack = entityPlayer.getHeldItem();
            if(itemStack == null)return null;
            if(itemStack.getItem() instanceof I_BlockInfoTerm){
                Block b = world.getBlock(msg.posX, msg.posY, msg.posZ);
                String unlocname = b.getUnlocalizedName();
                String locname = b.getLocalizedName();
                int meta = world.getBlockMetadata(msg.posX, msg.posY, msg.posZ);
                int blockid = Block.getIdFromBlock(b);
                int lightlv = b.getLightValue();
                float hardness = b.getBlockHardness(world, msg.posX, msg.posY, msg.posZ);
                int harv = b.getHarvestLevel(meta);
                entityPlayer.addChatMessage(
                        new ChatComponentText(
                                String.format(
                                        "@x=%d, y=%d, z=%d: id=%d, meta=%d, UnlocalizedName=%s, LocalizedName=%s, LightLevel=%d, Hardness=%f, HarvestLevel=%d",
                                        msg.posX, msg.posY, msg.posZ, blockid, meta, unlocname, locname, lightlv, hardness, harv
                                )
                        )
                );
            }
            return null;
        }
    }
}
