package com.zjinja.mcmod.decor.registers;

import com.zjinja.mcmod.decor.ZJinJaDecoration;
import com.zjinja.mcmod.decor.element_base.EBaseTileBlock;
import com.zjinja.mcmod.decor.element_templates.renderer.WaveFrontRenderer;
import com.zjinja.mcmod.decor.misc.RenderResource;
import cpw.mods.fml.client.registry.ClientRegistry;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.tileentity.TileEntity;
import net.minecraftforge.client.model.obj.WavefrontObject;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;

public class TileEntityModelBinder {
    public TileEntityModelBinder(){

    }

    public void LoadModels(){
        LinkedList<RenderResource> renderResources = ZJinJaDecoration.proxy.Registry.RenderModelList;
        for(RenderResource iv : renderResources){
            iv.RenderModel = new WavefrontObject(iv.ModelResource);
        }
    }

    public void AutoBind(){
        HashMap<String, EBaseTileBlock> TileList = ZJinJaDecoration.proxy.Registry.GetTileBlockList();
        if(ZJinJaDecoration.DebugMode){
            ZJinJaDecoration.logger.warn("Auto TileRenderer Binding Loop...");
        }
        for (Map.Entry<String, EBaseTileBlock> iv : TileList.entrySet()) {
            if (iv.getValue().AutoBindRenderer()) {
                if(ZJinJaDecoration.DebugMode){
                    ZJinJaDecoration.logger.warn("[AutoTileRendererBind] " + iv.getKey());
                }
                EBaseTileBlock eBaseTileBlock = iv.getValue();
                ClientRegistry.bindTileEntitySpecialRenderer(
                        eBaseTileBlock.TEClass,
                        (TileEntitySpecialRenderer) eBaseTileBlock.GetTileRenderer()
                );
            }
        }
    }
}
