package com.zjinja.mcmod.decor.utils.model_dir_util;

public enum PlaceSideEnum {
    FaceToSky(0),
    FaceToGround(1),
    FaceToSouth(2),
    FaceToNorth(3),
    FaceToEast(4),
    FaceToWest(5);

    private int value;

    private PlaceSideEnum(int value) {     //必须是private的，否则编译错误
        this.value = value;
    }

    public static PlaceSideEnum valueOf(int value) {
        switch (value) {
            case 0:
                return FaceToSky;
            case 1:
                return FaceToGround;
            case 2:
                return FaceToSouth;
            case 3:
                return FaceToNorth;
            case 4:
                return FaceToEast;
            case 5:
                return FaceToWest;
            default:
                return FaceToSky;
        }
    }

    public static PlaceSideEnum fromYaw(int yaw){
        switch (yaw % 4){
            case 0:
                return FaceToSouth;
            case 1:
                return FaceToWest;
            case 2:
                return FaceToNorth;
            case 3:
                return FaceToEast;
            default:
                return FaceToSky;
        }
    }

    public static int TransToRotation(PlaceSideEnum pse){
        switch (pse){
            case FaceToNorth:
                return 0;
            case FaceToEast:
                return 1;
            case FaceToSouth:
                return 2;
            case FaceToWest:
                return 3;
            default:
                return -1;
        }
    }

}
